function [cost grad] = costfunction(params,il,hl,ol,X, y, lambda)
%calculate cost and gradient
param1 = reshape(params(1:hl * (il + 1)),hl, (il + 1));

param2 = reshape(params((1 + (hl * (il + 1))):end), ol, (hl + 1));

m = size(X, 1);
         
cost = 0;
param1_grad = zeros(size(param1));
param2_grad = zeros(size(param2));


X=[ones(m,1) X];

for i=1:m
    Y=zeros(ol,1);
    z2=param1*X(i,:)';
    a2=sigmoid(z2);
    a2=[1 ; a2];
    z3=param2*a2;
    h=sigmoid(z3);
    Y(y(i))=1;
    for j=1:ol
        cost=cost+-Y(j)*log(h(j))-(1-Y(j))*log(1-h(j));
    end
    delta3=h-Y;
    delta2=param2'*delta3.*sigmoidGradient([1;z2]); 
    param1_grad=param1_grad+delta2(2:end)*X(i,:); 
    param2_grad=param2_grad+delta3*a2';
end
cost=cost/m;
sumtheta1=sum(param1.^2);
sumtheta2=sum(param2.^2);
cost=cost+lambda/(2*m)*(sum(sumtheta1(2:il+1))+sum(sumtheta2(2:hl+1)));
param1_grad=param1_grad/m;
param2_grad=param2_grad/m;
param1_grad(:,2:il+1)=param1_grad(:,2:il+1)+param1(:,2:il+1)*lambda/m;
param2_grad(:,2:hl+1)=param2_grad(:,2:hl+1)+param2(:,2:hl+1)*lambda/m;

grad = [param1_grad(:) ; param2_grad(:)];


end
